VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "oDate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim mDate As Date

Function init(ByVal Value As Date) As oDate
  mDate = Value
  Set init = Me
End Function

Property Get Day() As Long
  Day = VBA.Day(mDate)
End Property

Property Get Month() As Long
  Month = VBA.Month(mDate)
End Property

Property Get Year() As Long
  Year = VBA.Year(mDate)
End Property

Function Offset(ByVal Value As Long, ByVal Unit As String) As oDate
  Dim DateItem As Date
  Set Offset = New oDate

  Select Case UCase(Unit)
    Case "Y"
      Offset.init DateSerial(VBA.Year(mDate) + Value, VBA.Month(mDate), VBA.Day(mDate))
    Case "M"
      DateItem = DateSerial(VBA.Year(mDate), VBA.Month(mDate) + Value, VBA.Day(mDate))
      If VBA.Day(DateItem) <> VBA.Day(mDate) Then DateItem = DateSerial(VBA.Year(DateItem), VBA.Month(DateItem), 0)
      Offset.init DateItem
    Case "D"
      Offset.init mDate + Value
  End Select
End Function

Property Get IsEndOfMonth() As Boolean
  IsEndOfMonth = VBA.Month(mDate) <> VBA.Month(mDate + 1)
End Property

Property Get DayOfWeek(Optional FirstWeekDay As VbDayOfWeek = vbMonday) As Long
  DayOfWeek = WeekDay(mDate, FirstWeekDay)
End Property

Property Get IsFirstDayOfYear() As Boolean
  IsFirstDayOfYear = VBA.Year(mDate) <> VBA.Year(mDate - 1)
End Property

Property Get IsFirstDayOfMonth() As Boolean
  IsFirstDayOfMonth = VBA.Day(mDate) = 1
End Property

Property Get IsEndOfYear() As Boolean
  IsEndOfYear = VBA.Year(mDate) <> VBA.Year(mDate + 1)
End Property

Property Get ToLong() As Long
  ToLong = mDate * 1
End Property

Property Get ToDate() As Date
  ToDate = mDate
End Property

Property Get Inc() As oDate
  Set Inc = New oDate
  Inc.init mDate + 1
End Property

Property Get Dec() As oDate
  Set Dec = New oDate
  Dec.init mDate - 1
End Property

Property Get EndOfMonth() As oDate
  Set EndOfMonth = New oDate
  EndOfMonth.init DateSerial(VBA.Year(mDate), VBA.Month(mDate) + 1, 0)
End Property

Property Get EndOfYear() As oDate
  Set EndOfYear = New oDate
  EndOfYear.init DateSerial(VBA.Year(mDate) + 1, 1, 0)
End Property

Property Get FirstDayOfMonth() As oDate
  Set FirstDayOfMonth = New oDate
  FirstDayOfMonth.init mDate - (VBA.Day(mDate) - 1)
End Property

Property Get FirstDayOfYear() As oDate
  Set FirstDayOfYear = New oDate
  FirstDayOfYear.init DateSerial(VBA.Year(mDate), 1, 1)
End Property

Property Get FirstDayOfWeek(Optional FirstWeekDay As VbDayOfWeek = vbMonday) As oDate
  Set FirstDayOfWeek = New oDate
  FirstDayOfWeek.init mDate - (WeekDay(mDate, FirstWeekDay) - 1)
End Property

Property Get LastDayOfWeek(Optional FirstWeekDay As VbDayOfWeek = vbMonday) As oDate
  Set LastDayOfWeek = New oDate
  LastDayOfWeek.init mDate - (WeekDay(mDate, FirstWeekDay) - 1) + 6
End Property

Property Get LastDayOfMonth() As oDate
  Set LastDayOfMonth = New oDate

  LastDayOfMonth.init DateSerial(VBA.Year(mDate), VBA.Month(mDate) + 1, 0)
End Property

Property Get LongDate() As String
  LongDate = StrConv(Format(mDate, "Dddd dd/mm/yyyy"), vbProperCase)
End Property

Property Get MonthName() As String
  MonthName = Format(mDate, "mmmm")
End Property

Property Get MonthNameAndYear()
  MonthNameAndYear = Format(mDate, "mmmm yyyy")
End Property

Property Get WeekdayName() As String
  WeekdayName = Format(mDate, "dddd")
End Property

Property Get LastDayOfYear() As oDate
  Set LastDayOfYear = New oDate
  LastDayOfYear.init DateSerial(VBA.Year(mDate) + 1, 1, 0)
End Property

Property Get Quarter() As Long
  Quarter = Int((VBA.Month(mDate) - 1) / 3) + 1
End Property

Property Get FirstDayOfQuarter() As oDate
  Set FirstDayOfQuarter = New oDate
  FirstDayOfQuarter.init DateSerial(VBA.Year(mDate), (Int((VBA.Month(mDate) - 1) / 3) + 1) * 3 - 2, 1)
End Property

Property Get LastDayOfQuarter() As oDate
  Set LastDayOfQuarter = New oDate
  LastDayOfQuarter.init DateSerial(VBA.Year(mDate), (Int((VBA.Month(mDate) - 1) / 3) + 1) * 3 + 1, 0)
End Property

Property Get ToString(Pattern As String) As String
  ToString = Format(mDate, Pattern)
End Property

Property Get IsLeapYear() As Boolean
  Dim y As Long
  
  y = VBA.Year(mDate)
  IsLeapYear = (y Mod 400 = 0) Or ((y Mod 4 = 0) And (y Mod 100 > 0))
End Property


'********************
' PRIVATE
'********************

Private Sub Class_Initialize()
  mDate = Date
End Sub
